## python-larch 0.26

=== Makefile ===
# Makefile for B-tree implementation
# Copyright 2010  Lars Wirzenius
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


all: fsck-larch.1
	$(MAKE) -C doc html

fsck-larch.1: fsck-larch.1.in fsck-larch
	./fsck-larch --generate-manpage=fsck-larch.1.in > fsck-larch.1

check:
	python -m CoverageTestRunner --ignore-missing-from=without-tests
	rm .coverage
	./insert-remove-test tempdir 100
	rm -r tempdir larch.log
	
clean:
	rm -f .coverage *.py[co] larch/*.py[co] insert.prof lookup.prof
	rm -rf build tempdir larch.log example.tree
	rm -f fsck-larch.1
	$(MAKE) -C doc clean

## python-larch 0.25

=== debian/changelog ===
python-larch (0.25-1) unstable; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Sun, 02 Oct 2011 21:18:26 +0100

python-larch (0.24-1) unstable; urgency=low

  * Install fsck-larch manpage.
  * Weaken python-ttystatus dependency to a recommends, since it's only
    needed by fsck-larch.

 -- Lars Wirzenius <liw@liw.fi>  Wed, 31 Aug 2011 17:15:27 +0100

python-larch (0.23-1) unstable; urgency=low

  * Add dependency on python-ttystatus. Thanks, Jo Shields, for the
    report.
  * Replace Sphinx copy of jquery.js with a symlink.

 -- Lars Wirzenius <liw@liw.fi>  Fri, 19 Aug 2011 19:47:43 +0100

python-larch (0.22-1) unstable; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Wed, 03 Aug 2011 15:44:57 +0100

python-larch (0.21-1) unstable; urgency=low

  * New upstream release.
  * Change package to be non-native.
  * Add build-dependency on python-cliapp.
  * fsck-larch manpage build disabled, until ttystatus is in Debian.

 -- Lars Wirzenius <liw@liw.fi>  Tue, 02 Aug 2011 20:00:24 +0100

python-larch (0.20) unstable; urgency=low

  * New upstream release. This is the first release to be uploaded to
    Debian. (Closes: #631864)
  * Package description has been improved.
  * debian/pycompat: removed for being useless.
  * Updated to use dh_python2.

 -- Lars Wirzenius <liw@liw.fi>  Wed, 20 Jul 2011 22:24:18 +0100

python-larch (0.19) squeeze; urgency=low

  * New upstream version.
  * New source package name, due to new upstream name.

 -- Lars Wirzenius <liw@liw.fi>  Mon, 21 Mar 2011 06:29:39 +0000

python-btree (0.18) squeeze; urgency=low

  * New upstream version.

 -- Lars Wirzenius <liw@liw.fi>  Fri, 18 Feb 2011 22:10:21 +0000

python-btree (0.17) squeeze; urgency=low

  * New upstream version.

 -- Lars Wirzenius <liw@liw.fi>  Sun, 13 Feb 2011 16:39:38 +0000

python-btree (0.16.2) squeeze; urgency=low

  * New upstream release.
    - fix all problems with modifying nodes while they are in the upload queue
    - performance has degraded

 -- Lars Wirzenius <liw@liw.fi>  Sun, 30 Jan 2011 09:51:40 +0000

python-btree (0.16.1) squeeze; urgency=low

  * New upstream release.
    - remove temporary nodes used while splitting a leaf node
    - prevent too-large leaf nodes from getting pushed out of the upload
      queue during splitting
    - introduce explicit maximum size for values stored in the tree
      (slightly less than half the size of a node)

 -- Lars Wirzenius <liw@liw.fi>  Sun, 09 Jan 2011 11:38:16 +0000

python-btree (0.16) squeeze; urgency=low

  * New upstream release.
    - fix bug that resulted in many very small leaf nodes

 -- Lars Wirzenius <liw@liw.fi>  Fri, 07 Jan 2011 22:00:14 +0000

python-btree (0.15) squeeze; urgency=low

  * New upstream release.
    - replace bsearch with bisect, which results in speedups

 -- Lars Wirzenius <liw@liw.fi>  Sun, 02 Jan 2011 21:56:23 +0000

python-btree (0.14) squeeze; urgency=low

  * New upstream release.
  * debian/control: Require at least version 0.4 of python-lru, since that's
    the version that provides the API we need for UploadQueue.

 -- Lars Wirzenius <liw@liw.fi>  Wed, 29 Dec 2010 19:38:04 +0000

python-btree (0.13) squeeze; urgency=low

  * New upstream release.
    - NodeStoreDisk's LRU cache size is user settable

 -- Lars Wirzenius <liw@liw.fi>  Tue, 13 Jul 2010 09:15:33 +1200

python-btree (0.12) squeeze; urgency=low

  * New upstream release.
  * debian/control: Added Python-Version headers.
  * debian/control: Bumped Standards-Version. No other changes required.

 -- Lars Wirzenius <liw@liw.fi>  Sun, 11 Jul 2010 19:13:43 +1200

python-btree (0.11) squeeze; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Mon, 05 Jul 2010 17:27:50 +1200

python-btree (0.10) squeeze; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Tue, 29 Jun 2010 15:36:25 +1200

python-btree (0.9) squeeze; urgency=low

  * Add check that setup.py (i.e., btree/__init__.py) and debian/changelog
    agree on version. 
  * Node and NodeCodec have been optimized a bit. 
  * NodeStoreDisk uses small LRU cache to avoid repeatedly reading the same
    nodes from disk. This adds dependency on python-lru.
  * NodeCodec uses four-byte magic cookies, instead of one-byte ones.

 -- Lars Wirzenius <liw@liw.fi>  Wed, 26 May 2010 21:52:22 +1200

python-btree (0.8) squeeze; urgency=low

  * Fix leaf node merging. 

 -- Lars Wirzenius <liw@liw.fi>  Sun, 09 May 2010 18:50:47 +1200

python-btree (0.7) squeeze; urgency=low

  * lookup_range now returns keys in ascending order. 

 -- Lars Wirzenius <liw@liw.fi>  Sun, 09 May 2010 17:49:35 +1200

python-btree (0.6) squeeze; urgency=low

  * Fix lookup_range for case when a node's children contain keys in
    the range, but the first key is not one of them.

 -- Lars Wirzenius <liw@liw.fi>  Sat, 08 May 2010 21:05:55 +1200

python-btree (0.5) squeeze; urgency=low

  * Fix emptied forests and empty trees handling. 

 -- Lars Wirzenius <liw@liw.fi>  Sat, 08 May 2010 20:31:55 +1200

python-btree (0.4) squeeze; urgency=low

  * Fix NodeStoreDisk._load_metadata to use self.file_exists instead of
    os.path.exists directly.

 -- Lars Wirzenius <liw@liw.fi>  Sat, 08 May 2010 16:21:09 +1200

python-btree (0.3) squeeze; urgency=low

  * Fix RefcountStore to work even without changes. 

 -- Lars Wirzenius <liw@liw.fi>  Sat, 08 May 2010 14:02:14 +1200

python-btree (0.2) squeeze; urgency=low

  * Make NodeStoreDisk sub-classable. 

 -- Lars Wirzenius <liw@liw.fi>  Sat, 08 May 2010 13:19:20 +1200

python-btree (0.1) squeeze; urgency=low

  * Fix packaging so it installs things under /usr, not /. 

 -- Lars Wirzenius <liw@liw.fi>  Sat, 08 May 2010 12:58:47 +1200

python-btree (0.0) squeeze; urgency=low

  * Initial packaging. This is not intended to be uploaded to Debian, so
    no closing of an ITP bug.

 -- Lars Wirzenius <liw@liw.fi>  Sat, 08 May 2010 11:10:24 +1200

=== debian/control ===
Source: python-larch
Maintainer: Lars Wirzenius <liw@liw.fi>
Section: python
Priority: optional
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 7.3.8), python (>= 2.6.6-3~), 
    python-coverage-test-runner, python-tracing, python-sphinx,
    python-cliapp (>= 0.14), python-ttystatus
X-Python-Version: >= 2.6

Package: python-larch
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-tracing, 
    python-cliapp (>= 0.14), libjs-jquery
Recommends: python-ttystatus
Description: B-tree library for Python
 An implementation of a particular kind of B-tree, based on research
 by Ohad Rodeh. This is the same data structure that btrfs uses, but
 in a new, pure-Python implementation.
 .
 The distinctive feature of this B-tree is that a node is never (conceptually)
 modified. Instead, all updates are done by copy-on-write. This makes it
 easy to clone a tree, and modify only the clone, while other processes
 access the original tree.
 .
 The implementation is generic and flexible, so that you may use it in
 a variety of situations. For example, the tree itself does not decide
 where its nodes are stored: you provide a class that does that for it.
 The library contains two implementations, one for in-memory and one
 for on-disk storage.

## python-larch 1.20121006

=== Makefile ===
--- 
+++ 
@@ -26,6 +26,7 @@
 	rm .coverage
 	./insert-remove-test tempdir 100
 	rm -r tempdir larch.log
+	cmdtest tests
 	
 clean:
 	rm -f .coverage *.py[co] larch/*.py[co] insert.prof lookup.prof

## python-larch 1.20131130

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/larch.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/larch.qhc"

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

## python-larch 1.20151025

=== Makefile ===
--- 
+++ 
@@ -27,9 +27,13 @@
 	./insert-remove-test tempdir 100
 	rm -r tempdir larch.log
 	cmdtest tests
+	./codec-speed -n1000
+	./idpath-speed 1 t.idspeed-test 10 5 1 && rm -r t.idspeed-test
+	./refcount-speed --refs=1000
+	./speed-test --location t.speed-test --keys 1000
 	
 clean:
 	rm -f .coverage *.py[co] larch/*.py[co] insert.prof lookup.prof
-	rm -rf build tempdir larch.log example.tree
+	rm -rf build tempdir larch.log example.tree t.idspeed-test t.speed-test
 	rm -f fsck-larch.1
 	$(MAKE) -C doc clean

=== debian/changelog ===
python-larch (1.20151025-1) unstable; urgency=low

  * New upstream version.
  * debian/control: Add Homepage: to source stanza.
  * debian/control: Update Standards-Version to 3.9.5. No further
    changes required.
  * Change source format to 3.0 (quilt).

 -- Lars Wirzenius <liw@liw.fi>  Sun, 25 Oct 2015 12:32:05 +0200

python-larch (1.20131130-1) unstable; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Sat, 30 Nov 2013 09:50:25 +0000

python-larch (1.20130808-1) unstable; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Thu, 08 Aug 2013 21:51:05 +0100

python-larch (1.20130316-1) unstable; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Sat, 16 Mar 2013 10:41:30 +0000

python-larch (1.20121216-1) unstable; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Sun, 16 Dec 2012 19:00:56 +0000

python-larch (1.20121006-1) unstable; urgency=low

  * New upstream release.
    - Fix "UnboundLocalError: local variable 'new_node' referenced before
      assignment" (Closes: #675818)
  * debian/control: Add missing build-dependency on cmdtest.

 -- Lars Wirzenius <liw@liw.fi>  Sat, 06 Oct 2012 10:27:20 +0100

python-larch (1.20120527-1) unstable; urgency=low

  * New upstream release.
    - New version scheme. Thank you, Joey Hess.
    - The on-disk data structures and file formats are now declared frozen.
      An automatic test has been added to verify that things do not break.

 -- Lars Wirzenius <liw@liw.fi>  Sun, 27 May 2012 11:42:28 +0200

python-larch (0.31-1) unstable; urgency=low

  * New upstream version.

 -- Lars Wirzenius <liw@liw.fi>  Tue, 08 May 2012 22:30:10 +0100

python-larch (0.30-1) unstable; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Sun, 29 Apr 2012 20:32:49 +0100

python-larch (0.29-1) unstable; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Sun, 15 Apr 2012 20:15:54 +0100

python-larch (0.28-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Standards-Version bumped. No other changes
    required.

 -- Lars Wirzenius <liw@liw.fi>  Sun, 25 Mar 2012 17:09:50 +0100

python-larch (0.27-1) unstable; urgency=low

  * New upstream release.

 -- Lars Wirzenius <liw@liw.fi>  Sat, 18 Feb 2012 23:26:03 +0000

python-larch (0.26-1) unstable; urgency=low

  * New upstream release.
  * debian/control: change libjs-jquery to Suggests, from Depends. It's only
    needed for API documentation, which most people won't care about.
  * debian/control, debian/python-larch.links: replace embedded underscore.js
    with a symlink.
  * debian/source/format: switch back to the simple 1.0 source format.

 -- Lars Wirzenius <liw@liw.fi>  Sun, 18 Dec 2011 15:35:54 +0000

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,20 @@
 Source: python-larch
 Maintainer: Lars Wirzenius <liw@liw.fi>
+Homepage: http://liw.fi/larch/
 Section: python
 Priority: optional
-Standards-Version: 3.9.2
-Build-Depends: debhelper (>= 7.3.8), python (>= 2.6.6-3~), 
+Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 7.3.8), python (>= 2.6.6-3~),
     python-coverage-test-runner, python-tracing, python-sphinx,
-    python-cliapp (>= 0.14), python-ttystatus
+    python-cliapp (>= 0.14), python-ttystatus, cmdtest
 X-Python-Version: >= 2.6
 
 Package: python-larch
 Architecture: all
-Depends: ${python:Depends}, ${misc:Depends}, python-tracing, 
-    python-cliapp (>= 0.14), libjs-jquery
+Depends: ${python:Depends}, ${misc:Depends}, python-tracing,
+    python-cliapp (>= 0.14)
 Recommends: python-ttystatus
+Suggests: libjs-jquery, libjs-underscore
 Description: B-tree library for Python
  An implementation of a particular kind of B-tree, based on research
  by Ohad Rodeh. This is the same data structure that btrfs uses, but

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with=python2 --buildsystem=python_distutils

override_dh_auto_build:
	$(MAKE)
	dh_auto_build --with=python2 --buildsystem=python_distutils

override_dh_auto_clean:
	$(MAKE) clean
	dh_auto_clean --with=python2 --buildsystem=python_distutils
